/*
 * ex12.cu
 * This is an exercise for learning the memory management in CUDA.
 */
#include <stdio.h>
#define SIZE 16

int main(int argc, char *argv[])
{
  int size = SIZE;
  
  /* Variables declaration */
  char input[SIZE] = "Correct output";
  char *output;
  char *cudaMemory;

  /* Allocate memory in CPU */
  output = (char *)malloc( size * sizeof(char) );

  /* Allocate memory in GPU */
  cudaMalloc( (void **)&cudaMemory, size * sizeof(char) );

  /* Memory copy from CPU to GPU */
  cudaMemcpy( cudaMemory, input, size * sizeof(char), cudaMemcpyHostToDevice );

  /* Memory copy from GPU to CPU */
  cudaMemcpy( output, cudaMemory, size * sizeof(char), cudaMemcpyDeviceToHost );

  /* Print the output */
  printf( "%s\n", output );

  /* Free up the GPU memory */  
  cudaFree(cudaMemory);

  /* Free up the CPU memory */
  free(output);

  return 0;
}
