/*
  ex17.cu
  This is an optional exercise to get start writing 
  a CUDA implementation of matrix multiplication.
*/
#include <stdio.h>

void matrix_multiply(const int *mat1, const int *mat2, int *result, int width);

int main(int argc, char *argv[])
{
  int i, j;

  /* Variables for CPU matrix multiplication */
  int *mat1;
  int *mat2;
  int *resultFromCPU;

  /* Variable for GPU matrix multiplication */
  int *cudaMat1;
  int *cudaMat2;
  int *cudaResult;
  /* Variable to store the results calculated by GPU in host memory */
  int *resultFromGPU;

  /* Assume square matrix */
  int width = 8;

  mat1 = (int *)malloc( width * width * sizeof(int) );
  mat2 = (int *)malloc( width * width * sizeof(int) );
  resultFromCPU = (int *)malloc( width * width * sizeof(int) );
  resultFromGPU = (int *)malloc( width * width * sizeof(int) );

  /* Initialize the matrices */
  for( j = 0; j < width; j++ )
  {
    for( i = 0; i < width; i++ )
    {
      mat1[j * width + i] = (int) (i + j);
      mat2[j * width + i] = (int) (i - j);
    }
  }

  /* Call CPU matrix multiplication function */
  matrix_multiply(mat1, mat2, resultFromCPU, width);

  /* Printing out input and result matrices */
  printf( "Input matrices\n" );

  for( j = 0; j < width; j++ )
  {
    for( i = 0; i < width; i++ )
      printf( "%d ", mat1[j*width + i] );

    printf( "\t\t" );

    for( i = 0; i < width; i++ )
      printf( "%d ", mat2[j*width + i] );

    printf( "\n" );
  }
  
  printf( "\n\nResult matrix\n" );
  for( j = 0; j < width; j++ )
  {
    for( i = 0; i < width; i++ )
    {
      printf( "%d ", resultFromCPU[j*width + i] );
    }
    printf( "\n" );
  }
  
  /*******************************************************/
  /* Your implementation below */
  /*******************************************************/



  free(mat1);
  free(mat2);
  free(resultFromCPU);
  free(resultFromGPU);

  return 0;
}

void matrix_multiply(const int *mat1, const int *mat2, int *result, int width)
{
  int i, j, temp;

  for( j = 0; j < width; j++ )
  {
    for( i = 0; i < width; i++ )
    {
      result[j*width + i] = 0;
      for( temp = 0; temp < width; temp++ )
      {
	result[j*width + i] += mat1[j*width + temp] * mat2[temp*width + i];
      }
    }
  }
}
