/*
  multigpu.cu
  This is a simple exercise showing how to run multiple GPUs.
*/

#include <stdio.h>

__global__ void hello_kernel(int i)
{
  printf( "Hello from device %d, thread %d, block %d\n", i, threadIdx.x, blockIdx.x );
}

int main()
{
  int i;

  int ngpus;
  cudaGetDeviceCount(&ngpus);

  for( i = 0; i < ngpus; i++ )
  {
    cudaSetDevice(i);
    hello_kernel<<< 2, 2 >>>(i);
  }

  for( i = 0; i < ngpus; i++ )
  {
    cudaSetDevice(i);
    cudaDeviceReset();
  }

  return 0;
}
